![Jtech Logo](http://www.jtech.com.br/wp-content/uploads/2015/06/logo.png)

# MQTT-Publisher

Esse publicador foi desenvolvido para ajudar o teste no desenvolvido do serviço da
GroupLink, ele usa o Mosquitto como um servidor MQTT e publica as mensagens que estiverem
no objeto json no campo `responses`

### Requisito

- Rode o docker-compose composer/mosquitto-docker-compose.yml
    - `docker-compose -f ./composer/mosquitto-docker-composer.yml`
- Instale os requisitos para o programa
    - `pip install -r requirements.txt`
- Ajuste as configurações no arquivo `config.json`
    - broker: endereço do broker
    - port: porta do broker
    - schedule: de quanto em quanto tempo deve publicar mensagens
    - keep_alive: quanto tempo deve se manter conectado
    - topic: nome do tópico a ser publicado
    - client_id: Id do cliente que irá se comunicar
    - responses: lista de objetos json que será publicado

Exemplo do protocolo de comunicação do GroupLink
```json
{
   "channels": [
      {
         "activated_at": 1666713600000,
         "channel": 0,
         "device_offset": 0,
         "unit": "m³",
         "last_reading": 490422,
         "read_at": 1680718323551,
         "name": "CGR-310",
         "remote_id": "11",
         "alerts": [],
         "raw_offset": 68758129,
         "device_pulse_factor": 1
      }
   ],
   "device_id": 3617382278,
   "last_seen": 1680718323551,
   "meta": {
      "latitude": -20.52793,
      "longitude": -54.56595,
      "display_address": "-20.527930, -54.565950"
   }
}
```

### Executando

```shell
 ./python mqtt-publisher.py
```